## Apache Zeta Components Manual :: Docs For Class ezcImageGeometryFilters

### ImageConversion::ezcImageGeometryFilters

### Interface ezcImageGeometryFilters

This interface has to implemented by ezcImageFilters classes to support geometry filters.

Source for this file: /ImageConversion/src/interfaces/geometry.php

Version: | //autogentag//

### Constants

`SCALE_BOTH = 1` | Scale up and down, as fits
`SCALE_DOWN = 2` | Scale down only
`SCALE_UP = 3` | Scale up only

### Method Summary

public void | `crop( $x , $y , $width , $height )` Crop filter.
public void | `scale( $width , $height , [ $direction = ezcImageGeometryFilters::SCALE_BOTH] )` Scale filter.
public void | `scaleExact( $width , $height )` Scale exact filter.
public void | `scaleHeight( $height , $direction )` Scale after height filter.
public void | `scalePercent( $width , $height )` Scale percent measures filter.
public void | `scaleWidth( $width , $direction )` Scale after width filter.

### Methods

#### crop

void crop( int $x , int $y , int $width , int $height )

Crop filter.

Crop an image to a given size. This takes cartesian coordinates of a rect area to crop from the image. The cropped area will replace the old image resource (not the input image immediately, if you use the ezcImageConverter). Coordinates are given as integer values and are measured from the top left corner.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$x` | int | Start cropping, x coordinate.
`$y` | int | Start cropping, y coordinate.
`$width` | int | Width of cropping area.
`$height` | int | Height of cropping area.

##### Exceptions:

Type | Description
--- | ---
`ezcImageInvalidReferenceException` | If no valid resource for the active reference could be found.
`ezcImageFilterFailedException` | If the operation performed by the the filter failed.
`ezcBaseValueException` | If a submitted parameter was out of range or type.

#### scale

void scale( int $width , int $height , [int $direction = ezcImageGeometryFilters::SCALE_BOTH] )

Scale filter.

General scale filter. Scales the image to fit into a given box size, determined by a given width and height value, measured in pixel. This method maintains the aspect ratio of the given image. Depending on the given direction value, this method performs the following scales:

- ezcImageGeometryFilters::SCALE_BOTH: The image will be scaled to fit exactly into the given box dimensions, no matter if it was smaller or larger as the box before.
- ezcImageGeometryFilters::SCALE_DOWN: The image will be scaled to fit exactly into the given box only if it was larger than the given box dimensions before. If it is smaller, the image will not be scaled at all.
- ezcImageGeometryFilters::SCALE_UP: The image will be scaled to fit exactly into the given box only if it was smaller than the given box dimensions before. If it is larger, the image will not be scaled at all. ATTENTION: In this case, the image does not necessarily fit into the given box afterwards.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$width` | int | Scale to width
`$height` | int | Scale to height
`$direction` | int | Scale to which direction.

##### Exceptions:

Type | Description
--- | ---
`ezcImageInvalidReferenceException` | If no valid resource for the active reference could be found.
`ezcImageFilterFailedException` | If the operation performed by the the filter failed.
`ezcBaseValueException` | If a submitted parameter was out of range or type.

#### scaleExact

void scaleExact( int $width , int $height )

Scale exact filter.

Scale the image to a fixed given pixel size, no matter to which direction.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$width` | int | Scale to width
`$height` | int | Scale to height

##### Exceptions:

Type | Description
--- | ---
`ezcImageInvalidReferenceException` | If no valid resource for the active reference could be found.
`ezcImageFilterFailedException` | If the operation performed by the the filter failed.
`ezcBaseValueException` | If a submitted parameter was out of range or type.

#### scaleHeight

void scaleHeight( int $height , int $direction )

Scale after height filter.

Scales the image to a give height, measured in pixel. Scales the width automatically while keeping the ratio. The direction dictates, if an image may only be scaled self::SCALE_UP, self::SCALE_DOWN or if the scale may work in self::SCALE_BOTH directions.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$height` | int | Scale to height
`$direction` | int | Scale to which direction

##### Exceptions:

Type | Description
--- | ---
`ezcImageInvalidReferenceException` | If no valid resource for the active reference could be found.
`ezcImageFilterFailedException` | If the operation performed by the the filter failed.
`ezcBaseValueException` | If a submitted parameter was out of range or type.

#### scalePercent

void scalePercent( int $width , int $height )

Scale percent measures filter.

Scale an image to a given percentage value size.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$width` | int | Scale to width
`$height` | int | Scale to height

##### Exceptions:

Type | Description
--- | ---
`ezcImageInvalidReferenceException` | If no valid resource for the active reference could be found.
`ezcImageFilterFailedException` | If the operation performed by the the filter failed.
`ezcBaseValueException` | If a submitted parameter was out of range or type.

#### scaleWidth

void scaleWidth( int $width , int $direction )

Scale after width filter.

Scales the image to a give width, measured in pixel. Scales the height automatically while keeping the ratio. The direction dictates, if an image may only be scaled self::SCALE_UP, self::SCALE_DOWN or if the scale may work in self::SCALE_BOTH directions.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$width` | int | Scale to width
`$direction` | int | Scale to which direction

##### Exceptions:

Type | Description
--- | ---
`ezcImageInvalidReferenceException` | If no valid resource for the active reference could be found.
`ezcImageFilterFailedException` | If the operation performed by the the filter failed.
`ezcBaseValueException` | If a submitted parameter was out of range or type.

Documentation generated by phpDocumentor 1.4.3